//+------------------------------------------------------------------+
//|                                             Period_Converter.mq4 |
//|                 Copyright  2005-2007, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"
#property show_inputs
#include <WinUser32.mqh>

extern int ExtPeriodMultiplier=3; // new period multiplier factor
int        ExtHandle=-1;
//+------------------------------------------------------------------+
//| script program start function                                    |
//+------------------------------------------------------------------+
int start()
  {
   int    i, start_pos,start_pos_1, i_time, time0, last_fpos, periodseconds;
   double d_open, d_low, d_high, d_close, d_volume, last_volume,d_open_1, d_close_1;
   int    hwnd=0,cnt=0;
//---- History header
   int    version=400;
   string c_copyright;
   string c_symbol="SPREADGS";
   int    i_period=Period()*ExtPeriodMultiplier;
   int    i_digits=Digits;
   int    i_unused[13];
//----  
   ExtHandle=FileOpenHistory(c_symbol+i_period+".hst", FILE_BIN|FILE_WRITE);
   if(ExtHandle < 0) return(-1);
//---- write history file header
   c_copyright="(C)opyright 2003, MetaQuotes Software Corp.";
   FileWriteInteger(ExtHandle, version, LONG_VALUE);
   FileWriteString(ExtHandle, c_copyright, 64);
   FileWriteString(ExtHandle, c_symbol, 12);
   FileWriteInteger(ExtHandle, i_period, LONG_VALUE);
   FileWriteInteger(ExtHandle, i_digits, LONG_VALUE);
   FileWriteInteger(ExtHandle, 0, LONG_VALUE);       //timesign
   FileWriteInteger(ExtHandle, 0, LONG_VALUE);       //last_sync
   FileWriteArray(ExtHandle, i_unused, 0, 13);
//---- write history file
   periodseconds=i_period*60;
   if (iBars("SILVER",0)>iBars("GOLD",0))
      {
      start_pos=iBars("GOLD",0)-1;      
      }
   else
      {
      start_pos=iBars("SILVER",0)-1;      
      }
   d_open=iOpen("GOLD",0,start_pos)/iOpen("SILVER",0,start_pos);
   d_close=iClose("GOLD",0,start_pos)/iClose("SILVER",0,start_pos);
   if (d_open>d_close)
   {
    d_low=d_close;
    d_high=d_open;
   }
   else
   {
    d_high=d_close;
    d_low=d_open;
   }
   d_volume=iVolume("GOLD",0,start_pos)+iVolume("SILVER",0,start_pos);
   //---- normalize open time
   i_time=iTime("SILVER",0,start_pos)/periodseconds;
   i_time*=periodseconds;
   for(i=start_pos-1;i>=0; i--)
     {
      time0=iTime("SILVER",0,i);
      //---- history may be updated
      if(i==0)
        {
         //---- modify index if history was updated
         if(RefreshRates())
            i=iBarShift(NULL,0,time0);
        }
      //----
      if(time0>=i_time+periodseconds || i==0)
        {
         if(i==0 && time0<i_time+periodseconds)
           {
            d_volume+=iVolume("GOLD",0,i)+iVolume("SILVER",0,i);
            d_open_1=iOpen("GOLD",0,0)/iOpen("SILVER",0,0);
            d_close_1=iClose("GOLD",0,0)/iClose("SILVER",0,0);
            if (d_open_1>d_close_1)
            {
              d_low=d_close_1;
              d_high=d_open_1;
            }
            else
            {
              d_high=d_close_1;
              d_low=d_open_1;  
            }
            d_close=d_close_1;
           }
         last_fpos=FileTell(ExtHandle);
         last_volume=iVolume("GOLD",0,i)+iVolume("SILVER",0,i);
         FileWriteInteger(ExtHandle, i_time, LONG_VALUE);
         FileWriteDouble(ExtHandle, d_open, DOUBLE_VALUE);
         FileWriteDouble(ExtHandle, d_low, DOUBLE_VALUE);
         FileWriteDouble(ExtHandle, d_high, DOUBLE_VALUE);
         FileWriteDouble(ExtHandle, d_close, DOUBLE_VALUE);
         FileWriteDouble(ExtHandle, d_volume, DOUBLE_VALUE);
         FileFlush(ExtHandle);
         cnt++;
         if(time0>=i_time+periodseconds)
           {
            i_time=time0/periodseconds;
            i_time*=periodseconds;
            d_open_1=iOpen("GOLD",0,i)/iOpen("SILVER",0,i);
            d_close_1=iClose("GOLD",0,i)/iClose("SILVER",0,i);
            if (d_open_1>d_close_1)
            {
              d_low=d_close_1;
              d_high=d_open_1;
            }
            else
            {
              d_high=d_close_1;
              d_low=d_open_1;  
            }
            d_open=d_open_1;
            d_close=d_close_1;
            d_volume=last_volume;
           }
        }
       else
        {
         d_volume+=iVolume("GOLD",0,i)+iVolume("SILVER",0,i);
         d_open_1=iOpen("GOLD",0,i)/iOpen("SILVER",0,i);
         d_close_1=iClose("GOLD",0,i)/iClose("SILVER",0,i);
         if (d_open_1>d_close_1)
          {
            d_low=d_close_1;
            d_high=d_open_1;
          }
         else
          {
            d_high=d_close_1;
            d_low=d_open_1;  
          }
          d_close=d_close_1;
        }
     } 
   FileFlush(ExtHandle);
   Print(cnt," record(s) written");
//---- collect incoming ticks
   int last_time=LocalTime()-5;
   while(IsStopped()==false)
     {
      int cur_time=LocalTime();
      //---- check for new rates
      if(RefreshRates())
        {
         time0=iTime("SILVER",0,0);
         FileSeek(ExtHandle,last_fpos,SEEK_SET);
         //---- is there current bar?
         if(time0<i_time+periodseconds)
           {
            d_volume+=(iVolume("GOLD",0,0)+iVolume("SILVER",0,0))-last_volume;
            last_volume=iVolume("GOLD",0,0)+iVolume("SILVER",0,0); 
            d_open_1=iOpen("GOLD",0,0)/iOpen("SILVER",0,0);
            d_close_1=iClose("GOLD",0,0)/iClose("SILVER",0,0);
            if (d_open_1>d_close_1)
            {
              d_low=d_close_1;
              d_high=d_open_1;
            }
            else
            {
              d_high=d_close_1;
              d_low=d_open_1;  
            }
            d_close=d_close_1;
           }
         else
           {
            //---- no, there is new bar
            d_volume+=(iVolume("GOLD",0,1)+iVolume("SILVER",0,1))-last_volume;
            d_open_1=iOpen("GOLD",0,1)/iOpen("SILVER",0,1);
            d_close_1=iClose("GOLD",0,1)/iClose("SILVER",0,1);
            if (d_open_1>d_close_1)
            {
              d_low=d_close_1;
              d_high=d_open_1;
            }
            else
            {
              d_high=d_close_1;
              d_low=d_open_1;  
            }
            //---- write previous bar remains
            FileWriteInteger(ExtHandle, i_time, LONG_VALUE);
            FileWriteDouble(ExtHandle, d_open, DOUBLE_VALUE);
            FileWriteDouble(ExtHandle, d_low, DOUBLE_VALUE);
            FileWriteDouble(ExtHandle, d_high, DOUBLE_VALUE);
            FileWriteDouble(ExtHandle, d_close, DOUBLE_VALUE);
            FileWriteDouble(ExtHandle, d_volume, DOUBLE_VALUE);
            last_fpos=FileTell(ExtHandle);
            //----
            i_time=time0/periodseconds;
            i_time*=periodseconds;
            d_open_1=iOpen("GOLD",0,0)/iOpen("SILVER",0,0);
            d_close_1=iClose("GOLD",0,0)/iClose("SILVER",0,0);
            if (d_open_1>d_close_1)
            {
              d_low=d_close_1;
              d_high=d_open_1;
            }
            else
            {
              d_high=d_close_1;
              d_low=d_open_1;  
            }
            d_open=d_open_1;
            d_close=d_close_1;
            d_volume=iVolume("GOLD",0,0)+iVolume("SILVER",0,0);
            last_volume=d_volume;
           }
         //----
         FileWriteInteger(ExtHandle, i_time, LONG_VALUE);
         FileWriteDouble(ExtHandle, d_open, DOUBLE_VALUE);
         FileWriteDouble(ExtHandle, d_low, DOUBLE_VALUE);
         FileWriteDouble(ExtHandle, d_high, DOUBLE_VALUE);
         FileWriteDouble(ExtHandle, d_close, DOUBLE_VALUE);
         FileWriteDouble(ExtHandle, d_volume, DOUBLE_VALUE);
         FileFlush(ExtHandle);
         //----
         if(hwnd==0)
           {
            hwnd=WindowHandle(Symbol(),i_period);
            if(hwnd!=0) Print("Chart window detected");
           }
         //---- refresh window not frequently than 1 time in 2 seconds
         if(hwnd!=0 && cur_time-last_time>=2)
           {
            PostMessageA(hwnd,WM_COMMAND,33324,0);
            last_time=cur_time;
           }
        }
      Sleep(50); 
     }      
//----
   return(0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void deinit()
  {
   if(ExtHandle>=0) { FileClose(ExtHandle); ExtHandle=-1; }
  }
//+------------------------------------------------------------------+